/*************************************************************************
Title........ outputdev.h
Date......... Fri Jul  9 10:08:42  1999
Author....... J.M.Tarrant
*************************************************************************/

/****	Defines */


	#define		EOF_OUTPUTS		-1
//	#define		DUM_OUTPUT		-2
	#define		DUM_OUTPUT		-1


	#define		OP0		16
	#define		OP1		17
	#define		OP2		18
	#define		OP3		19
	#define		OP4		20
	#define		OP5		21
	#define		OP6		22
	#define		OP7		23

	#define		OP8		0
	#define		OP9		1
	#define		OP10	2
	#define		OP11	3
	#define		OP12	4
	#define		OP13	5
	#define		OP14	6
	#define		OP15	7

	#define		OP16	48
	#define		OP17	49
	#define		OP18	50
	#define		OP19	51
	#define		OP20	52
	#define		OP21	53
	#define		OP22	54
	#define		OP23	55

	#define		OP24	32
	#define		OP25	33
	#define		OP26	34
	#define		OP27	35
	#define		OP28	36
	#define		OP29	37
	#define		OP30	38
	#define		OP31	39

	#define		OP32	80
	#define		OP33	81
	#define		OP34	82
	#define		OP35	83
	#define		OP36	84
	#define		OP37	85
	#define		OP38	86
	#define		OP39	87

	#define		OP40	64
	#define		OP41	65
	#define		OP42	66
	#define		OP43	67
	#define		OP44	68
	#define		OP45	69
	#define		OP46	70
	#define		OP47	71

	#define		OP48	112
	#define		OP49	113
	#define		OP50	114
	#define		OP51	115
	#define		OP52	116
	#define		OP53	117
	#define		OP54	118
	#define		OP55	119

	#define		OP56	96
	#define		OP57	97
	#define		OP58	98
	#define		OP59	99
	#define		OP60	100
	#define		OP61	101
	#define		OP62	102
	#define		OP63	103

/****	Type Definitions */

typedef	WORD OUTPUT;

typedef	struct outputmap
	{
	LONG	map0;
	LONG	map1;
	LONG	map2;
	LONG	map3;
	} OUTPUTMAP;

typedef	struct	outputconfig
	{
	const	OUTPUT*	voplist;
	} OUTPUTCFG;

typedef	struct	outputvars
	{
	const	OUTPUTCFG*	config;
	} OUTPUTVARS;

typedef	struct	outputzvars
	{
	OUTPUTMAP	outputmap;
	} OUTPUTZVARS;

typedef struct outputservices
	{
	void	(*outputon)(const OUTPUT op);
	void	(*outputoff)(const OUTPUT op);
	void	(*writelownibble)(WORD idx,BYTE data);
	void	(*writehighnibble)(WORD idx,BYTE data);
	} OUTPUTSERVICES;

/****	Prototypes */

	#include	"outputdev.p"

/*************************************************************************/
