/*************************************************************************
Title........ timermod.h
Date......... Mon Jul  5 12:17:05  1999
Author....... J.M.Tarrant
*************************************************************************/

/****	Defines */

	#define	TIMER1_BASE	SIM40_BASE+0x600
	#define	TMR1_MCR		REGW(TIMER1_BASE+0x00)
	#define	TMR1_IR			REGW(TIMER1_BASE+0x04)
	#define	TMR1_CR			REGW(TIMER1_BASE+0x06)
	#define	TMR1_SR			REGW(TIMER1_BASE+0x08)
	#define	TMR1_CNTR		REGW(TIMER1_BASE+0x0A)
	#define	TMR1_PREL1		REGW(TIMER1_BASE+0x0C)
	#define	TMR1_PREL2		REGW(TIMER1_BASE+0x0E)
	#define	TMR1_COM		REGW(TIMER1_BASE+0x10)

	#define	TIMER2_BASE	SIM40_BASE+0x640
	#define	TMR2_MCR		REGW(TIMER2_BASE+0x00)
	#define	TMR2_IR			REGW(TIMER2_BASE+0x04)
	#define	TMR2_CR			REGW(TIMER2_BASE+0x06)
	#define	TMR2_SR			REGW(TIMER2_BASE+0x08)
	#define	TMR2_CNTR		REGW(TIMER2_BASE+0x0A)
	#define	TMR2_PREL1		REGW(TIMER2_BASE+0x0C)
	#define	TMR2_PREL2		REGW(TIMER2_BASE+0x0E)
	#define	TMR2_COM		REGW(TIMER2_BASE+0x10)



/*	bits in status register								*/
	#define	TMR_TO			0x4000
	#define	TMR_TG			0x2000
	#define	TMR_TC			0x1000
	#define	TO_ENB_BITS		(TMR_TO+TMR_TG+TMR_TC)

/*	bits in module configuration register					*/
	#define	TMR_SWR			0x8000



/****	Type Definitions */
/* timer configuration structure */
typedef	struct
		{
		UWORD	mcr;
		UWORD	ir;
		UWORD	prel1;
		UWORD	prel2;
		UWORD	com;
		UWORD	cr;
		} TIMERCFG;


/****	Prototypes */

	#include	"timermod.p"

/*************************************************************************/
