/* uart.c */
extern const DEVICE UARTDevice;
extern void UartISR(void);
extern BYTE InstallUART(const DEVICE *dev, WORD cfg, WORD base);
extern void ShutdownUART(const DEVICE *dev);
extern void RestoreUART(const DEVICE *dev);
extern BYTE ConfigureUART(const DEVICE *dev, BYTE txBaud, BYTE rxBaud, BYTE data, BYTE stop, BYTE parity, BYTE txhs, BYTE rxhs);
extern BYTE TxUART(const DEVICE *dev, char ch);
extern WORD RxUART(const DEVICE *dev);
extern BYTE TxUARTEmpty(const DEVICE *dev);
extern BYTE RxUARTEmpty(const DEVICE *dev);
extern void ClearTxUART(const DEVICE *dev);
extern void ClearRxUART(const DEVICE *dev);
