/* vga.s */
extern ULONG load_image(const UBYTE *startaddr, ULONG offset, ULONG size);
extern ULONG load_mask(const UBYTE *startaddr, ULONG offset, ULONG size);
extern ULONG load_mask16(const UBYTE *startaddr, ULONG offset, ULONG size);
extern ULONG create_mask(ULONG offset, ULONG size);
extern ULONG create_mask16(ULONG offset, ULONG size);
extern void clear_video_memory(WORD color, ULONG offset, ULONG size);
extern void fast_load_palette(ULONG startaddr, ULONG paletteaddr);
extern void cremson_load_palette(ULONG startaddr, ULONG paletteaddr);
extern void byte_swap(ULONG offset, ULONG size);
extern void enable_ide_regs();
extern void disable_ide_regs();
extern void enable_byte_swap();
extern void disable_byte_swap();
extern UWORD* VideoMemBase;
extern LONG	 HSIZE;
extern LONG	 VSIZE;
extern LONG	 HPITCH;